<?php

/**
 * Implementation of hook_drush_command().
 */
function dropfort_update_drush_command() {
  $items = array();

  $items['dropfort-register'] = array(
    'description' => "Prints the Dropfort registration link for this site.",
    'arguments' => array(),
    'options' => array(),
    'aliases' => array('dfr'),
    'bootstrap' => DRUSH_BOOTSTRAP_DRUPAL_FULL,
  );

  return $items;
}


/**
 * Callback for dropfort-register.
 */
function drush_dropfort_update_dropfort_register() {
  if (module_exists('dropfort_update')) {
    drush_print(_dropfort_update_site_registration_link(TRUE));
  }
  else {
    drush_set_error("Dropfort Update not installed", dt('You must enable the dropfort_update module for your site before registering with Dropfort.'));
  }
}


/**
 * Try to avoid duplicate declaration issues with Drush
 */
if (!function_exists('drush_dropfort_update_pre_pm_download')) {
  /**
   * Implements drush_hook_pre_COMMAND().
   */
  function drush_dropfort_update_pre_pm_download($project) {
    $options = drush_get_merged_options();

    $dropfort_update_url = !empty($options['dropfort_url']) ? $options['dropfort_url'] : 'https://app.dropfort.com';
    $token = '';
    $usertoken = !empty($options['dropfort_userauth_token']) ? $options['dropfort_userauth_token'] : '';

    // Only try to load settings from Drupal if it's present
    if (function_exists('variable_get')) {
      $dropfort_update_url = variable_get('dropfort_update_base_url', $dropfort_update_url);
      $token = variable_get('dropfort_update_site_token', '');
    }

    if ($options['source'] and $options['source'] == $dropfort_update_url . '/fserver/release-history') {
      if (!empty($token)) {
        drush_set_option('source', $dropfort_update_url . '/fserver/release-history-auth/' . $token);
      }
      elseif (!empty($usertoken)) {
        drush_set_option('source', $dropfort_update_url . '/fserver/release-history-userauth/' . $usertoken);
      }
      else {
        drush_set_error('DROPFORT_UPDATE_MISSING_AUTH_TOKEN', dt('Unable to find an authentication token to download projects from !url', array('!url'=> $dropfort_update_url)));
      }
    }
  }
}
